#!/usr/bin/env python

'''

    @version $Id: graphics.py,v 1.1 2005/09/19 06:21:54 dave Exp $

    This file is part of mathguy.

    mathguy is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    mathguy is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with mathguy; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    mathguy is copyright 2005 by David Fancella

'''

import pygame
from pygame.locals import *

# This file contains graphics helper functions that don't really belong anywhere
# else but need to have the same flags and stuff when created

# Tileimage takes a surface that contains the image you want to tile and the size
# of the surface to tile on.  It returns a surface of that size tiled.
def TileImage(image, size):
    tmpSurf = pygame.Surface(size)
    width = image.get_width()
    height = image.get_height()

    for a in range(0, size[0], width):
        for b in range(0, size[1], height):
            tmpSurf.blit(image, (a,b) )

    tmpSurf.convert()
    return tmpSurf

# takes a path and returns a surface
def LoadImage(image):
    return pygame.image.load(image)
    
def Surface(size):
    return pygame.Surface(size, SWSURFACE|SRCALPHA, 32)

def Rect(pos):
    tmpRect = pygame.Rect(pos)
    return tmpRect

