#!/usr/bin/env python

'''

    @version $Id: mg_billboard.py,v 1.1 2005/09/17 23:34:49 dave Exp $

    This file is part of pyAlarm.

    acme is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    acme is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with acme; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    acme is copyright 2005 by David Fancella

'''

import pygame
from pygame.locals import *
from libGUIacme import font
from libacme import paths
from libGUIacme.libwidget import *
from libGUIacme.widgets import mg_widget
# Event constants

# return from event handler
mgENONEOFYOURBUSINESS = 0
mgESELECTION = 1

# pass to event handler
mgEMOUSECLICK = 2
mgEKEYBOARD = 3
mgEMOUSEMOVE = 6

# used internally by the event system
mgEBASEEVENT = 4
mgEINPUTEVENT = 5

class mgBillboard(mg_widget.mgWidgetBase):
    text = None
    textLabel = None
    width = 500
    rasterWidth = None
    
    def __init__(self, **args):
        super(mgBillboard, self).__init__(**args)
        if args.has_key("width"):
            self.width = args['width']

        self.rasterWidth = self._getRasterCoordinate( (self.width, 0) )[0]
            
        if args.has_key("text"):
            self.text = args['text']
            self.textLabel = font.mgLabel(
                            args['text'],
                            font=self.font,
                            pos = self.rasterPos,
                            width = self.rasterWidth
                        )
        else:
            self.text = ''
            self.textLabel = font.mgLabel(
                            self.text,
                            font=self.font,
                            pos = self.rasterPos,
                            width = self.rasterWidth
                        )

    def setText(self, text):
        self.textLabel.setText(text)
        self.text = text

    def GetBottomRasterPos(self):
        (lblX, lblY) = self.textLabel.getSize()
        
        return (self.rasterPos[0]), (self.rasterPos[1] + lblY)
                        
    def UpdateView(self, screen, timetick):
        self.textLabel.render(screen)

    
        
