#!/usr/bin/env python

'''

    @version $Id: mg_event.py,v 1.2 2005/09/27 04:40:44 dave Exp $

    This file is part of acme.

    acme is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    acme is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with acme; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    acme is copyright 2005 by David Fancella

'''

import pygame
from pygame.locals import *
from libGUIacme import font
from libacme import paths
from libGUIacme.libwidget import *
from libGUIacme.widgets import mg_event
from libGUIacme import graphics
from libGUIacme.widgets import mg_widget
from libGUIacme.widgets.mg_constants import *

class mgEButtonClick(mg_event.mgMouseClick):
    mgEType = mgEBUTTONCLICK

# This class represents a clickable button that may be toggled
class mgButton(mg_widget.mgWidgetBase):
    canToggle = False
    caption = None
    isDirty = True
    isToggled = False
    
    def __init__(self, **args):
        super(mgButton, self).__init__(**args)
        
        if args.has_key('toggle'):
            self.canToggle = args['toggle']
        if args.has_key('caption'):
            self.caption = args['caption']
        else:
            self.caption = ''

        self.bevelSize = 1
        
        self.mgFont = font.mgFont(self.fontName, size=self.fontSize)
        self.DrawText()
        self.rect = self.textImage.get_rect()
        self.rect.inflate_ip( (10,10) )
        self.image = graphics.Surface( (self.rect.width, self.rect.height) )
        self.SetPos(self.pos)
        self.DrawButton()

        self.RegisterHandler(mgEMOUSECLICK, self.OnMouseClick, None)

    def OnMouseClick(self, event):
        if self.rect.collidepoint(event.pos):
            if self.canToggle:
                self.isToggled = not self.isToggled
                self.isDirty = True
            self.DispatchEvent( mgEButtonClick(source=self) )

    def DrawBackground(self):
        self.image.fill( (200,200,200, 255) )

    def DrawText(self):
        self.textImage = self.mgFont.fprint(self.caption, self.fontColor)

    def DrawButton(self):
        self.DrawBackground()
        self.DrawText()
        self.image.blit(self.textImage, (5,4))
        if self.canToggle is True:
            if self.isToggled is True:
                self.DrawDecoration()
            else:
                self.DrawAlternateDecoration()
    
    def update(self, timetick):
        if self.isDirty:
            self.DrawButton()
            self.isDirty = False

