#!/usr/bin/env python

'''

    @version $Id: mg_container.py,v 1.2 2005/09/27 04:40:44 dave Exp $

    This file is part of acme.

    acme is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    acme is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with acme; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    acme is copyright 2005 by David Fancella

'''

import pygame
from pygame.locals import *
from libGUIacme import font
from libacme import paths
from libGUIacme.libwidget import *
from libGUIacme.widgets import mg_widget

class mgContainer(mg_widget.mgWidgetBase):
    widgetList = None
    def __init__(self, **args):
        super(mgContainer, self).__init__(**args)
        self.widgetList = {}

    # adds a widget to be managed by this container
    def AddWidget(self, widget, process_events):
        self.widgetList[str(widget.widgetCount)] = widget
        
    def ShowWidget(self, widgetID):
        if self.widgetList.has_key(str(widgetID)):
            self.widgetList[str(widgetID)].SetVisible(True)

    def ShowGroup(self, group, show=True):
        for key, value in self.widgetList.iteritems():
            if value.Group() == group:
                value.SetVisible(show)
            else:
                value.SetVisible(not show)

    def HideWidget(self, widgetID):
        if self.widgetList.has_key(str(widgetID)):
            self.widgetList[str(widgetID)].SetVisible(False)

    def UpdateView(self, screen, timetick):
        for key, value in self.widgetList.iteritems():
            value._UpdateView(screen, timetick)

    # Use this when you don't need to get anything back from the event handler
    def processEvent(self, event):
        for key, value in self.widgetList.iteritems():
            value._processEvent(event)

    def _processEvent(self, event):
        self.processEvent(event)
        


