#!/usr/bin/env python

'''

    @version $Id: mg_event.py,v 1.2 2005/09/27 04:40:44 dave Exp $

    This file is part of acme.

    acme is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    acme is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with acme; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    acme is copyright 2005 by David Fancella

'''

import pygame
from pygame.locals import *
from libGUIacme import font
from libacme import paths
from libGUIacme.libwidget import *
from libGUIacme.widgets import mg_event
from libGUIacme import graphics
from libGUIacme.widgets import mg_widget
from libGUIacme.widgets.mg_constants import *

# a class that holds a string and renders it to the screen when asked
class mgLabel(mg_widget.mgWidgetBase):
    thefont = None
    text = None
    color = (255,255,255)
    lastColor = (255,255,255)
    pos = (0, 0)
    width = None
    
    # takes a mgFont object as its parameter, it'll use it to render the text
    def __init__(self, **args):
        super(mgLabel, self).__init__(**args)
        if args.has_key("text"):
            self.textString = args['text']
        else:
            self.textString = ''
        if args.has_key("font_color"):
            self.fontColor = args['font_color']
        else:
            self.fontColor = (0,0,0)
        if args.has_key("shadow_color"):
            self.shadowColor = args['shadow_color']
        else:
            self.shadowColor = (100,100,100)
        self.thefont = font.mgFont(self.fontName, size=self.fontSize, shadow_color=self.shadowColor)
        self.isDirty = True
        
    def setText(self, text):
        self.textString = text
        self.isDirty = True
        
    def DrawLabel(self):
        self.textImage = self.thefont.fprint(self.textString, self.fontColor)
        self.rect = self.textImage.get_rect()
        self.rect.inflate_ip( 10, 10 )
        self.SetPos(self.pos)
        self.image = graphics.Surface( (self.rect.width, self.rect.height) )
        
        self.image.blit(self.textImage, (5,5) )

    def update(self, timetick):
        if self.isDirty:
            self.DrawLabel()
            self.isDirty = False

    def UpdateView(self, screen):
        screen.blit(self.image, self.rect)

