#!/usr/bin/env python

'''

    @version $Id: mg_container.py,v 1.2 2005/09/27 04:40:44 dave Exp $

    This file is part of acme.

    acme is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    acme is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with acme; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    acme is copyright 2005 by David Fancella

'''

import pygame
from pygame.locals import *
from libGUIacme import font
from libacme import paths
from libGUIacme.libwidget import *
from libGUIacme.widgets import mg_widget
from libGUIacme import graphics

# This class is intended to be inherited
class mgPanel(mg_widget.mgWidgetBase):
    widgetList = None
    def __init__(self, **args):
        self.widgetList = []
        super(mgPanel, self).__init__(**args)
        self.bevelSize = 1
        self.isDirty = True

    # adds a widget to be managed by this container
    # offset is an offset from the panel's position.  Each overlying widget
    # will know it's actual position on the screen, but we need the offset
    # to be able to compute new positions
    def AddWidget(self, widget, offset):
        self.widgetList.append( (widget, offset) )
        self.SetPos(self.pos)

    def SetPos(self, pos):
        self.rect.topleft = pos
        for value in self.widgetList:
            newPos = (pos[0] + value[1][0], pos[1] + value[1][1])
            value[0].SetPos(newPos)
        self.isDirty = True

    def DrawBackground(self):
        self.image.fill( (100,100,100,100) )
        
    def update(self, timetick):
        if self.isDirty:
            self.DrawBackground()
            for value in self.widgetList:
                value[0].update(timetick)
            self.DrawDecoration()

    def UpdateView(self, screen):
        screen.blit(self.image, self.rect)
        for value in self.widgetList:
            value[0].UpdateView(screen)

        


