#!/usr/bin/env python

'''

    @version $Id: mg_event.py,v 1.2 2005/09/27 04:40:44 dave Exp $

    This file is part of acme.

    acme is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    acme is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with acme; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    acme is copyright 2005 by David Fancella

'''

import pygame
from pygame.locals import *
from libGUIacme import font
from libacme import paths
from libGUIacme.libwidget import *
from libGUIacme.widgets import mg_event
from libGUIacme import graphics
from libGUIacme.widgets import mg_widget
from libGUIacme.widgets.mg_constants import *

class mgEToolButtonClick(mg_event.mgMouseClick):
    mgEType = mgETOOLBUTTONCLICK

class mgEToolToggle(mg_event.mgMouseClick):
    mgEType = mgETOOLTOGGLE

# This class represents a clickable button that may be toggled
class mgToolButton(mg_widget.mgWidgetBase):
    canToggle = False
    caption = None
    isDirty = True
    isToggled = False
    
    def __init__(self, **args):
        if args.has_key('size'):
            self.size = args['size']
            del args['size']
        else:
            self.size = (32,32)
        super(mgToolButton, self).__init__(**args)

        if args.has_key('toggle'):
            self.canToggle = args['toggle']
        if args.has_key('icon'):
            self.iconFile = args['icon']
        else:
            raise NotImplemented, 'You need an icon in a tool button.'
        self.toolsize = self.size
        self.icon = pygame.image.load(self.iconFile)
                
        self.icon = pygame.transform.scale(self.icon, self.toolsize)
        self.icon.convert()

        self.bevelSize = 1
        
        self.DrawButton()

        self.RegisterHandler(mgEMOUSECLICK, self.OnMouseClick, None)

    def OnMouseClick(self, event):
        if self.rect.collidepoint(event.pos):
            if self.canToggle:
                self.isToggled = not self.isToggled
                self.isDirty = True
                self.DispatchEvent( mgEToolToggle(pos=event.pos, source=self) )
            else:
                self.DispatchEvent( mgEToolButtonClick(pos=event.pos, source=self) )

    def DrawBackground(self):
        self.image.fill( (200,200,200, 255) )

    def DrawButton(self):
        self.DrawBackground()
        self.image.blit(self.icon, (0,0) )
        if self.canToggle is True:
            if self.isToggled is True:
                self.DrawDecoration()
            else:
                self.DrawAlternateDecoration()
    
    def update(self, timetick):
        if self.isDirty:
            self.DrawButton()
            self.isDirty = False

