#!/usr/bin/env python

'''

    @version $Id: acme,v 1.6 2005/09/17 01:31:47 dave Exp $

    This file is part of acme.

    acme is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    acme is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with acme; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    acme is copyright 2005 by David Fancella

'''

import sys, os
import pygame
from pygame.locals import *

if sys.platform == 'win32':
    __basepath = ''
    __share = ''
    __lib = ''
else:
    __basepath = sys.path[0]
    if __basepath.startswith(sys.prefix):
        __share = os.path.join('share', 'mathguy')
        __lib = os.path.join('lib', 'mathguy')
    else:
        __share = ''
        __lib = ''

__allPaths = { 'resource' : os.path.join(__basepath, __share, "resources"),
               'graphics' : os.path.join(__basepath, __share, "resources", "graphics"),
               'icons' : os.path.join(__basepath, __share, 'resources', 'icons'),
               'fonts' : os.path.join(__basepath, __share, "resources", "fonts"),
               'dtd' : os.path.join(__basepath, __share, "resources", "dtd") }

# todo: make GetPath throw an exception or something instead if a path isn't known
def GetPath(path):
    if __allPaths.has_key(path):
        return __allPaths[path]
    else:
        return None

def LoadFont(fontname, size, module=None):
    fontfile = fontname + ".ttf"

    fontfile = SearchModulePath("fonts", fontfile, module)
    
    theFont = pygame.font.Font(fontfile, size)
    return theFont

def Join(mgpath, path):
    if GetPath(mgpath) is not None:
        return os.path.join(GetPath(mgpath), path)
    else:
        return None

def SearchModulePath(resource, file, module=None):
    # first search in the module's specific graphics directory
    if module is not None:
        tmpPath = Join(resource, module)
        if os.path.exists(tmpPath) and os.path.isdir(tmpPath):
            newPath = os.path.join(tmpPath, file)
            if os.path.exists(newPath) and os.path.isfile(newPath):
                return newPath
    
    newPath = Join(resource, file)
    if os.path.exists(newPath) and os.path.isfile(newPath):
        return newPath

    raise IOError, file + " not found"
    

        
        